﻿app.controller("accountController", function ($scope, myAccountService, $mdToast, $location) {

    $scope.NewAcc = function () {
        $scope.isLoading = true;

        var form =
        {
            email: $scope.email,
            name: $scope.name,
            company: $scope.company,
            password: $scope.password,
            plan : $scope.plan,
            country: $scope.country,
            vat: $scope.vat
        };

        var response = myAccountService.CreateAccount(form);
        response.then(function (res) {            
            if (res.data.success == true) {
                $mdToast.show(
                   $mdToast.simple()
                     .textContent(res.data.message)
                     .hideDelay(5000)
                );
                window.location.href = res.data.result;
            }
            else
            {
                $scope.isLoading = false;
                $mdToast.show(
                    $mdToast.simple()
                      .textContent(res.data.error)
                      .hideDelay(false)
                      .hideDelay(5000)
                   );
            }
        });
    }

    $scope.Login = function () {

        $scope.isLoading = true;

        var form =
        {
                user: $scope.user,
                pwd: $scope.pwd
        };

        var response = myAccountService.Login(form);
        response.then(function (res) {
            
            if (res.data.success == true) {
                $mdToast.show(
                   $mdToast.simple()
                     .textContent(res.data.message)
                     .hideDelay(5000)
                );
                window.location.href = res.data.result;
            }
            else {
                $scope.isLoading = false;
                $mdToast.show(
                    $mdToast.simple()
                      .textContent(res.data.error)
                      .hideDelay(false)
                      .hideDelay(5000)
                   );
            }
        });
    }

    $scope.Forgot = function () {

        $scope.isLoading = true;

        var response = myAccountService.Forgot($scope.email);

        response.then(function (res) {

            if (res.data.success == true) {
                $mdToast.show(
                    $mdToast.simple()
                        .textContent(res.data.message)
                        .hideDelay(5000)
                );
                window.location.href = res.data.result;
            }
            else {
                $scope.isLoading = false;
                $mdToast.show(
                    $mdToast.simple()
                        .textContent(res.data.error)
                        .hideDelay(false)
                        .hideDelay(5000)
                );
            }
        });
    }

    $scope.Reset = function () {

        $scope.isLoading = true;

        var form =
            {
                token: $scope.token,
                password: $scope.password,
                confirmPassword: $scope.confirmPassword
            };

        var response = myAccountService.Reset(form);
        response.then(function (res) {

            if (res.data.success == true) {
                $mdToast.show(
                    $mdToast.simple()
                        .textContent(res.data.message)
                        .hideDelay(5000)
                );
                window.location.href = res.data.result;
            }
            else {
                $scope.isLoading = false;
                $mdToast.show(
                    $mdToast.simple()
                        .textContent(res.data.error)
                        .hideDelay(false)
                        .hideDelay(5000)
                );
            }
        });
    }
});