﻿app.controller("apiController", function ($scope, myApiService, $mdToast, $mdDialog, $filter) {

    $scope.Actions = ["Insert",
        "Update",
        "Delete",
        "GetById",
        "Search",
        "Aggregate"];

    

    $scope.WiAreas = ["App",
        "Pages"];

    $scope.Verbs = ["GET",
        "POST",
        "PUT",
        "DELETE"];

    $scope.Formats = ["JSON",
        "XML"];

    $scope.StorageTypes = ["MongoDB", "Mysql"];

    $scope.secretkey = "";

    $scope.stage = 1;

    $scope.currentApp = "";

    $scope.displayInTestMode = false;

    $scope.displayMap = false;

    $scope.LoadingProjects = false;
    $scope.Projects = [];

    $scope.TestMode = function (display) {
        $scope.displayInTestMode = display
    };

    $scope.MapMode = function (display) {
        $scope.displayMap = display
    };

    $scope.Lists = [];

    $scope.List = function (container, filter) {
        myApiService
            .List(container, filter).then(function (res) {
                $scope.Lists.push(res.data);
            });
    };

    



    /*
       CONTAINERS
    */
    $scope.LoadingContainers = false;
    $scope.Containers = [];

    $scope.PreviewCc = function (cc, event) {
        $mdDialog.show(
            $mdDialog.alert()
                .title(cc.container + ' container')
                .textContent(cc.description)
                .ariaLabel('Container Details')
                .ok('Close')
                .targetEvent(event)
        );
    };

    $scope.AddCc = function () {

        $scope.isLoading = true;

        var form =
        {
            container: $scope.container,
            storagetype: $scope.storagetype,
            project: 'root',
            description: $scope.description
        };

        var response = myApiService.AddCc(form);
        response.then(function (res) {
            $scope.isLoading = false;
            if (res.data.success === true) {
                $mdToast.show(
                    $mdToast.simple()
                        .textContent(res.data.message)
                        .hideDelay(5000)
                );
                $scope.displayCcAdDetails = false;
                $scope.displayCcLsDetails = true;
                form._id = res.data.result;
                $scope.Containers.push(form);
            }
            else {
                $mdToast.show(
                    $mdToast.simple()
                        .textContent(res.data.error)
                        .hideDelay(5000)
                );
            }
        });
    };

    $scope.AddCcWz = function () {

        $scope.isLoading = true;

        var form =
        {
            container: $scope.container,
            storagetype: $scope.StorageTypes[0],
            project: $scope.currentApp,
            description: $scope.description
        };

        var response = myApiService.AddCcWz(form);
        response.then(function (res) {
            $scope.isLoading = false;
            if (res.data.success === true) {
                $mdToast.show(
                    $mdToast.simple()
                        .textContent(res.data.message)
                        .hideDelay(5000)
                );
                $scope.displayCcAdDetails = false;
                $scope.displayCcLsDetails = true;
                form._id = res.data.result;
                $scope.Containers.push(form);
            }
            else {
                $mdToast.show(
                    $mdToast.simple()
                        .textContent(res.data.error)
                        .hideDelay(5000)
                );
            }
        });
    };

    $scope.displayCcLsDetails = true;
    $scope.displayCcAdDetails = false;
    $scope.displayCcUpDetails = false;

    $scope.NewCc = function (display) {
        $scope.SelCc = null;
        $scope.displayCcAdDetails = display;
        $scope.displayCcLsDetails = !display;
        $scope.displayCcUpDetails = false;
    };

    $scope.SelCc = null;

    $scope.BeginUpdateCc = function (cc) {
        $scope.SelCc = cc;
        $scope.displayCcUpDetails = true;
        $scope.displayCcLsDetails = false;
    };

    $scope.UpdateCc = function () {

        $scope.isLoading = true;

        var form =
        {
            _id: $scope.SelCc._id,
            container: $scope.SelCc.container,
            storagetype: $scope.SelCc.storagetype,
            description: $scope.SelCc.description
        };

        var response = myApiService.UpdCc(form);
        response.then(function (res) {
            $scope.isLoading = false;
            if (res.data.success === true) {
                $mdToast.show(
                    $mdToast.simple()
                        .textContent(res.data.message)
                        .hideDelay(5000)
                );
                $scope.displayCcUpDetails = false;
                $scope.displayCcLsDetails = true;
            }
            else {
                $mdToast.show(
                    $mdToast.simple()
                        .textContent(res.data.error)
                        .hideDelay(5000)
                );
            }
        });
    };
    /*
       APPS
    */

    $scope.PreviewAp = function (ap, event) {
        $mdDialog.show(
            $mdDialog.alert()
                .title(ap.project)
                .textContent(ap.description)
                .ariaLabel('Project Details')
                .ok('Close')
                .targetEvent(event)
        );
    };

    $scope.AddApWz = function () {

        $scope.isLoading = true;

        var form =
        {
            project: $scope.project,
            description: $scope.description
        };

        var response = myApiService.AddApWz(form);
        response.then(function (res) {
            $scope.isLoading = false;
            if (res.data.success === true) {
                $mdToast.show(
                    $mdToast.simple()
                        .textContent(res.data.message)
                        .hideDelay(5000)
                );
                form._id = res.data.result;
                $scope.stage = 2;
                $scope.currentApp = form.project;
                $scope.Projects.push(form);
            }
            else {
                $mdToast.show(
                    $mdToast.simple()
                        .textContent(res.data.error)
                        .hideDelay(5000)
                );
            }
        });
    }

    $scope.ChangeStage = function (item) {
        if ($scope.currentApp)
            $scope.stage = item;
        else {
            $mdToast.show(
                $mdToast.simple()
                    .textContent("Please select one or create a new project before proceed.")
                    .hideDelay(5000)
            );
        }
    }

    $scope.AddAp = function () {

        $scope.isLoading = true;

        var form =
        {
            project: $scope.project,
            description: $scope.description
        };

        var response = myApiService.AddAp(form);
        response.then(function (res) {
            $scope.isLoading = false;
            if (res.data.success === true) {
                $mdToast.show(
                    $mdToast.simple()
                        .textContent(res.data.message)
                        .hideDelay(5000)
                );
                $scope.displayApAdDetails = false;
                $scope.displayApLsDetails = true;
                form._id = res.data.result;
                $scope.currentApp = form.project;
                $scope.Projects.push(form);
            }
            else {
                $mdToast.show(
                    $mdToast.simple()
                        .textContent(res.data.error)
                        .hideDelay(5000)
                );
            }
        });
    };

    $scope.displayApLsDetails = true;
    $scope.displayApAdDetails = false;
    $scope.displayApUpDetails = false;

    $scope.NewAp = function (display) {
        $scope.SelAp = null;
        $scope.displayApAdDetails = display;
        $scope.displayApLsDetails = !display;
        $scope.displayApUpDetails = false;
    };

    $scope.SelAp = null;

    $scope.BeginUpdateAp = function (ap) {
        $scope.SelAp = ap;
        $scope.displayApUpDetails = true;
        $scope.displayApLsDetails = false;
    };

    $scope.UpdateAp = function () {

        $scope.isLoading = true;

        var form =
        {
            _id: $scope.SelAp._id,
            project: $scope.SelAp.project,
            description: $scope.SelAp.description
        };

        var response = myApiService.UpdAp(form);
        response.then(function (res) {
            $scope.isLoading = false;
            if (res.data.success === true) {
                $mdToast.show(
                    $mdToast.simple()
                        .textContent(res.data.message)
                        .hideDelay(5000)
                );
                $scope.displayApUpDetails = false;
                $scope.displayApLsDetails = true;
            }
            else {
                $mdToast.show(
                    $mdToast.simple()
                        .textContent(res.data.error)
                        .hideDelay(5000)
                );
            }
        });
    };

    /*
        ENDPOINTS
    */
    $scope.LoadingEndpoints = false;
    $scope.Endpoints = [];

    $scope.PreviewEp = function (edp, event) {
        var pk = edp.root ? 'Ho' : $scope.PublicKeys[0].publickey;

        var testContent = JSON.stringify(edp.sample);
        var o = JSON.parse(testContent) // may throw if json is malformed
        testContent = JSON.stringify(o, null, 4) // 4 is the indent size

        $mdDialog.show(
            $mdDialog.alert()
                .title(edp.action + ' ' + edp.container)
                .htmlContent('Sample call:' +
                    '<p>url: https://jfk.hoxwi.com/Wi/' + pk + '/' + edp.name + '</p>' + '<p>Body: <br> <pre>' + testContent + '</pre></p>')
                .ariaLabel('Action')
                .ok('Close')
                .targetEvent(event)
        );
    };

    $scope.AddEp = function () {
        $scope.isLoading = true;
        var form =
        {
            name: $scope.name,
            storagetype: $scope.storagetype,
            container: $scope.container,
            project: $scope.project,
            action: $scope.action,
            restricted: $scope.restricted,
            description: $scope.description,
            preJs: $scope.preJs,
            posJs: $scope.posJs,
            projection: $scope.projection,
            aggregation: $scope.aggregation,
            active: $scope.active
        };

        var response = myApiService.AddEp(form);
        response.then(function (res) {
            $scope.isLoading = false;
            if (res.data.success === true) {
                $mdToast.show(
                    $mdToast.simple()
                        .textContent(res.data.message)
                        .hideDelay(3000)
                );
                $scope.displayEpAdDetails = false;
                $scope.displayEpLsDetails = true;
                form._id = res.data.result;
                $scope.Endpoints.push(form);
            }
            else {
                $mdToast.show(
                    $mdToast.simple()
                        .textContent(res.data.error)
                        .hideDelay(3000)
                );
            }
        });
    };

    $scope.AddEpWz = function () {
        $scope.isLoading = true;
        var form =
        {
            name: $scope.name,
            storagetype: $scope.StorageTypes[0],
            container: $scope.container,
            project: $scope.currentApp,
            action: $scope.action,
            restricted: false,
            description: $scope.description,
            aggregation: $scope.aggregation,
            projection: $scope.projection,
            preJs: '',
            posJs: '',
            active: true
        };

        var response = myApiService.AddEp(form);
        response.then(function (res) {
            $scope.isLoading = false;
            if (res.data.success === true) {
                $mdToast.show(
                    $mdToast.simple()
                        .textContent(res.data.message)
                        .hideDelay(3000)
                );
                $scope.displayEpAdDetails = false;
                $scope.displayEpLsDetails = true;
                form._id = res.data.result;
                $scope.Endpoints.push(form);
            }
            else {
                $mdToast.show(
                    $mdToast.simple()
                        .textContent(res.data.error)
                        .hideDelay(3000)
                );
            }
        });
    };
    $scope.DeleteEp = function (ep) {
        swal({
            title: "Attention", text: "This action can't be undone. Are you sure do you want to delete this Action?", type: "warning", showCancelButton: true, confirmButtonColor: "#DD6B55",
            confirmButtonText: "Yes", cancelButtonText: "No", closeOnConfirm: true
        }, function () {

            $scope.isLoading = true;
            var form =
            {
                _id: ep._id
            };

            var response = myApiService.DeleteEp(form);
            response.then(function (res) {
                $scope.isLoading = false;
                if (res.data.success === true) {
                    $mdToast.show(
                        $mdToast.simple()
                            .textContent(res.data.message)
                            .hideDelay(3000)
                    );
                    var index = $scope.Endpoints.indexOf(ep);
                    $scope.Endpoints.splice(index, 1);
                }
                else {
                    $mdToast.show(
                        $mdToast.simple()
                            .textContent(res.data.error)
                            .hideDelay(3000)
                    );
                }
            });
        });
    };

    $scope.displayEpLsDetails = true;
    $scope.displayEpAdDetails = false;
    $scope.displayEpUpDetails = false;

    $scope.NewEp = function (display) {
        $scope.SelEp = null;
        $scope.displayEpAdDetails = display;
        $scope.displayEpLsDetails = !display;
        $scope.displayEpUpDetails = false;
    };

    $scope.SelEp = null;

    $scope.BeginUpdateEp = function (cc) {
        $scope.SelEp = cc;
        $scope.displayEpUpDetails = true;
        $scope.displayEpLsDetails = false;
    };

    $scope.UpdateEp = function () {

        $scope.isLoading = true;

        var form =
        {
            _id: $scope.SelEp._id,
            name: $scope.SelEp.name,
            storagetype: $scope.SelEp.storagetype,
            container: $scope.SelEp.container,
            project: $scope.SelEp.project,
            action: $scope.SelEp.action,
            restricted: $scope.SelEp.restricted,
            description: $scope.SelEp.description,
            preJs: $scope.SelEp.preJs,
            posJs: $scope.SelEp.posJs,
            projection: $scope.SelEp.projection,
            aggregation: $scope.SelEp.aggregation,
            active: $scope.SelEp.active
        };

        var response = myApiService.UpdEp(form);
        response.then(function (res) {
            $scope.isLoading = false;
            if (res.data.success === true) {
                $mdToast.show(
                    $mdToast.simple()
                        .textContent(res.data.message)
                        .hideDelay(5000)
                );
                $scope.displayEpUpDetails = false;
                $scope.displayEpLsDetails = true;
            }
            else {
                $mdToast.show(
                    $mdToast.simple()
                        .textContent(res.data.error)
                        .hideDelay(5000)
                );
            }
        });
    };

    $scope.testMethod = 'POST';
    $scope.baseEndpoint = 'https://jfk.hoxwi.com';
    $scope.testEndpoint = '';
    $scope.testReady = false;

    $scope.SelectEp = function (edp, event) {
        $scope.SelEp = edp;
        $scope.testMethod = edp.verb;
        var pk = edp.root ? 'Ho' : $scope.PublicKeys[0].publickey;
        $scope.testEndpoint = '/' + pk + '/' + edp.name;
        var testContent = JSON.stringify(edp.sample);
        $scope.testReady = true;
        var jeditor = ace.edit("jeditor");
        jeditor.setTheme("ace/theme/vibrant_ink");
        jeditor.session.setMode("ace/mode/json");
        jeditor.getSession().setTabSize(2);
        jeditor.getSession().setUseWrapMode(true);
        var o = JSON.parse(testContent) // may throw if json is malformed
        testContent = JSON.stringify(o, null, 4) // 4 is the indent size
        jeditor.getSession().setValue(testContent);
        $('.nav-pills a[href="#htab2"]').tab('show');
        var rpeditor = ace.edit("rpeditor");
        rpeditor.getSession().setValue("");
    };

    $scope.isRunningEp = false;

    $scope.RunEp = function () {
        $scope.isRunningEp = true;

        var editor = ace.edit("jeditor");

        var form =
        {
            action: $scope.testMethod,
            url: $scope.baseEndpoint + $scope.testEndpoint,
            request: angular.fromJson(editor.getValue())
        };

        var response = myApiService.RunEp(form);
        response.then(function (res) {
            $scope.isRunningEp = false;
            if (res.data.success === true) {
                var respContent = JSON.stringify(res.data);
                var rpeditor = ace.edit("rpeditor");
                rpeditor.session.setMode("ace/mode/json");
                rpeditor.getSession().setTabSize(2);
                rpeditor.getSession().setUseWrapMode(true);
                var o = JSON.parse(respContent) // may throw if json is malformed
                rpeditor.getSession().setValue(JSON.stringify(o, null, 4));
                $('.nav-pills a[href="#htab4"]').tab('show');
            }
            else {
                $mdToast.show(
                    $mdToast.simple()
                        .textContent(res.data.error)
                        .hideDelay(3000)
                );
            }
        });
    };

    $scope.UpdateEpSample = function () {
        $scope.isLoading = true;
        var editor = ace.edit("jeditor");
        $scope.SelEp.sample = JSON.stringify(editor.getValue())

        var response = myApiService.UpdateEpSample($scope.SelEp);
        response.then(function (res) {
            $scope.isLoading = false;
            if (res.data.success === true) {
                $mdToast.show(
                    $mdToast.simple()
                        .textContent(res.data.message)
                        .hideDelay(3000)
                );
            }
            else {
                $mdToast.show(
                    $mdToast.simple()
                        .textContent(res.data.error)
                        .hideDelay(3000)
                );
            }
        });
    };


    /*
        PUBLIC KEYS
    */
    $scope.LoadingPublicKeys = false;

    $scope.PublicKeys = [];

    $scope.PreviewPk = function (pk, event) {
        $mdDialog.show(
            $mdDialog.alert()
                .title('Public Key ' + pk.description)
                .htmlContent('<p> Share the link bellow with your frontend development team and / or external partners <br> to let they access the documentation to access all endpoints related to <b>' + pk.project + '</b>.</p>' +
                    '<p class="text-center"><a target="_blank" class="btn btn-info btn-xs" href="https://jfk.hoxwi.com/Release/' + pk.publickey + '">Click here to access the documentation package</a></p>' +
                    '<p class="text-center">Direct link: <span class="text-danger"> https://jfk.hoxwi.com/Release/' + pk.publickey + '</span></p>' +
                    '<p><b>Remember</b> you don\'t need to share your account username/password to allow partners connecting to your APP.</p>')
                .ariaLabel('PK')
                .ok('Close')
                .targetEvent(event)
        );
    };

    $scope.AddPk = function () {

        $scope.isLoading = true;

        var form =
        {
            project: $scope.project,
            description: $scope.description,
            active: $scope.active
        };

        var response = myApiService.AddPk(form);
        response.then(function (res) {
            $scope.isLoading = false;
            if (res.data.success === true) {
                $mdToast.show(
                    $mdToast.simple()
                        .textContent(res.data.message)
                        .hideDelay(5000)
                );
                $scope.displayPkAdDetails = false;
                $scope.displayPkLsDetails = true;
                form._id = res.data.result;
                form.publickey = res.data.error;
                $scope.PublicKeys.push(form);
            }
            else {
                $mdToast.show(
                    $mdToast.simple()
                        .textContent(res.data.error)
                        .hideDelay(5000)
                );
            }
        });
    };

    $scope.AddPkWz = function () {

        $scope.isLoading = true;

        var form =
        {
            project: $scope.currentApp,
            description: $scope.description,
            active: true
        };

        var response = myApiService.AddPk(form);
        response.then(function (res) {
            $scope.isLoading = false;
            if (res.data.success === true) {
                $mdToast.show(
                    $mdToast.simple()
                        .textContent(res.data.message)
                        .hideDelay(5000)
                );
                $scope.displayPkAdDetails = false;
                $scope.displayPkLsDetails = true;
                form._id = res.data.result;
                form.publickey = res.data.error;
                $scope.PublicKeys.push(form);
            }
            else {
                $mdToast.show(
                    $mdToast.simple()
                        .textContent(res.data.error)
                        .hideDelay(5000)
                );
            }
        });
    };

    $scope.DeletePk = function (pk) {
        swal({
            title: "Attention", text: "This action can't be undone. Are you sure do you want to delete this Public Key?", type: "warning", showCancelButton: true, confirmButtonColor: "#DD6B55",
            confirmButtonText: "Yes", cancelButtonText: "No", closeOnConfirm: true
        }, function () {
            $scope.isLoading = true;
            var form =
            {
                _id: pk._id
            };

            var response = myApiService.DeletePk(form);
            response.then(function (res) {
                $scope.isLoading = false;
                if (res.data.success === true) {
                    $mdToast.show(
                        $mdToast.simple()
                            .textContent(res.data.message)
                            .hideDelay(3000)
                    );
                    var index = $scope.PublicKeys.indexOf(pk);
                    $scope.PublicKeys.splice(index, 1);
                }
                else {
                    $mdToast.show(
                        $mdToast.simple()
                            .textContent(res.data.error)
                            .hideDelay(3000)
                    );
                }
            });
        });
    };

    $scope.displayPkLsDetails = true;
    $scope.displayPkAdDetails = false;
    $scope.displayPkUpDetails = false;

    $scope.NewPk = function (display) {
        $scope.SelPk = null;
        $scope.displayPkAdDetails = display;
        $scope.displayPkLsDetails = !display;
        $scope.displayPkUpDetails = false;
    };

    $scope.SelPk = null;

    $scope.BeginUpdatePk = function (cc) {
        $scope.SelPk = cc;
        $scope.displayPkUpDetails = true;
        $scope.displayPkLsDetails = false;
    };

    $scope.UpdatePk = function () {

        $scope.isLoading = true;

        var form =
        {
            _id: $scope.SelPk._id,
            publickey: $scope.SelPk.publickey,
            project: $scope.SelPk.project,
            description: $scope.SelPk.description,
            active: $scope.SelPk.active
        };

        var response = myApiService.UpdPk(form);
        response.then(function (res) {
            $scope.isLoading = false;
            if (res.data.success === true) {
                $mdToast.show(
                    $mdToast.simple()
                        .textContent(res.data.message)
                        .hideDelay(5000)
                );
                $scope.displayPkUpDetails = false;
                $scope.displayPkLsDetails = true;
            }
            else {
                $mdToast.show(
                    $mdToast.simple()
                        .textContent(res.data.error)
                        .hideDelay(5000)
                );
            }
        });
    };

    /*
        Connectors
    */
    $scope.LoadingConnectors = false;
    $scope.Connectors = [];

    $scope.PreviewSc = function (scp, event) {
        $mdDialog.show(
            $mdDialog.alert()
                .title(scp.name + ' ' + scp.project)
                .htmlContent('<p>' + scp.description + '</p>' +
                    '<h4>Sample call:</h4>' +
                    '<p>url: https://jfk.hoxwi.com/Ho/' + $scope.PublicKeys[0].publickey + '/' + scp.name + '</p>' +
                    '<p>body: {name:"abc", reason:1234} </p>')
                .ariaLabel('Action access')
                .ok('Close')
                .targetEvent(event)
        );
    };

    $scope.AddSc = function () {
        $scope.isLoading = true;
        var form =
        {
            name: $scope.name,
            project: $scope.project,
            method: $scope.method,
            action: $scope.action,
            restricted: $scope.restricted,
            description: $scope.description,
            callcontent: $scope.callcontent,
            callheader: $scope.callheader,
            active: $scope.active,
            store: $scope.store,
            container: $scope.container,
            expectedformat: $scope.expectedformat,
            callformat: $scope.callformat,
            storagetype: $scope.storagetype
        };

        var response = myApiService.AddSc(form);
        response.then(function (res) {
            $scope.isLoading = false;
            if (res.data.success === true) {
                $mdToast.show(
                    $mdToast.simple()
                        .textContent(res.data.message)
                        .hideDelay(3000)
                );
                $scope.displayScAdDetails = false;
                $scope.displayScLsDetails = true;
                form._id = res.data.result;
                $scope.Connectors.push(form);
            }
            else {
                $mdToast.show(
                    $mdToast.simple()
                        .textContent(res.data.error)
                        .hideDelay(3000)
                );
            }
        });
    };

    $scope.DeleteSc = function (sc) {
        swal({
            title: "Attention", text: "This action can't be undone. Are you sure do you want to delete this Smart Connector?", type: "warning", showCancelButton: true, confirmButtonColor: "#DD6B55",
            confirmButtonText: "Yes", cancelButtonText: "No", closeOnConfirm: true
        }, function () {
            $scope.isLoading = true;
            var form =
            {
                _id: sc._id
            };

            var response = myApiService.DeleteSc(form);
            response.then(function (res) {
                $scope.isLoading = false;
                if (res.data.success === true) {
                    $mdToast.show(
                        $mdToast.simple()
                            .textContent(res.data.message)
                            .hideDelay(3000)
                    );
                    var index = $scope.Connectors.indexOf(sc);
                    $scope.Connectors.splice(index, 1);
                }
                else {
                    $mdToast.show(
                        $mdToast.simple()
                            .textContent(res.data.error)
                            .hideDelay(3000)
                    );
                }
            });
        });
    };

    $scope.displayScLsDetails = true;
    $scope.displayScAdDetails = false;
    $scope.displayScUpDetails = false;

    $scope.NewSc = function (display) {
        $scope.SelSc = null;
        $scope.displayScAdDetails = display;
        $scope.displayScLsDetails = !display;
        $scope.displayScUpDetails = false;
    };

    $scope.SelSc = null;

    $scope.BeginUpdateSc = function (cc) {
        $scope.SelSc = cc;
        $scope.displayScUpDetails = true;
        $scope.displayScLsDetails = false;
    };

    $scope.UpdateSc = function () {

        $scope.isLoading = true;

        var form =
        {
            _id: $scope.SelSc._id,
            name: $scope.SelSc.name,
            project: $scope.SelSc.project,
            method: $scope.SelSc.method,
            action: $scope.SelSc.action,
            restricted: $scope.SelSc.restricted,
            description: $scope.SelSc.description,
            callcontent: $scope.SelSc.callcontent,
            callheader: $scope.SelSc.callheader,
            active: $scope.SelSc.active,
            store: $scope.SelSc.store,
            container: $scope.SelSc.container,
            expectedformat: $scope.SelSc.expectedformat,
            callformat: $scope.SelSc.callformat,
            storagetype: $scope.SelSc.storagetype
        };

        var response = myApiService.UpdSc(form);
        response.then(function (res) {
            $scope.isLoading = false;
            if (res.data.success === true) {
                $mdToast.show(
                    $mdToast.simple()
                        .textContent(res.data.message)
                        .hideDelay(5000)
                );
                $scope.displayScUpDetails = false;
                $scope.displayScLsDetails = true;
            }
            else {
                $mdToast.show(
                    $mdToast.simple()
                        .textContent(res.data.error)
                        .hideDelay(5000)
                );
            }
        });
    };

    /*
    Logs
    */
    $scope.LoadingLog = false;
    $scope.Logs = [];

    $scope.PreviewLg = function (lg, event) {
        $mdDialog.show(
            $mdDialog.alert()
                .title(lg.endpoint + ' - ' + lg.date)
                .htmlContent('<p>' + lg.content + '</p>')
                .ariaLabel('Log')
                .ok('Close')
                .targetEvent(event)
        );
    };

    /*
    Account
    */
    $scope.LoadingAccount = true;
    $scope.Account = null;

    $scope.usageStats = "Calculating...";
    $scope.credit = "0.00";

    $scope.LoadTabs = function () {
        myApiService
            .GetData('all').then(function (data) {
                $scope.Account = data.data.account;
                $scope.LoadingAccount = false;
                $scope.usageStats = data.data.usageStats;
                $scope.credit = data.data.account.credit;
            });
    };

    $scope.UpdateAcc = function () {
        $scope.isLoading = true;
        var response = myApiService.UpdAcc($scope.Account);
        response.then(function (res) {
            $scope.isLoading = false;
            if (res.data.success === true) {
                $mdToast.show(
                    $mdToast.simple()
                        .textContent(res.data.message)
                        .hideDelay(5000)
                );
            }
            else {
                $mdToast.show(
                    $mdToast.simple()
                        .textContent(res.data.error)
                        .hideDelay(5000)
                );
            }
        });
    };

    $scope.LoadTabsWz = function () {
        myApiService
            .GetDataWz('all').then(function (data) {
                if (data.data.projects)
                    $scope.Projects = data.data.projects;

                $scope.LoadingProjects = false;

                if (data.data.publickeys)
                    $scope.PublicKeys = data.data.publickeys;

                $scope.LoadingPublicKeys = false;

                if (data.data.containers)
                    $scope.Containers = data.data.containers;

                $scope.LoadingContainers = false;

                if (data.data.endpoints)
                    $scope.Endpoints = data.data.endpoints;

                $scope.LoadingEndpoints = false;
                $scope.Account = data.data.account;
                $scope.LoadingAccount = false;
            });
    };

    $scope.LoadProjects = function () {
        if ($scope.Projects.length === 0 && !$scope.LoadingProjects) {
            $scope.LoadingProjects = true;
            myApiService
                .GetData('ap').then(function (data) {
                    $scope.Projects = data.data.projects;
                    $scope.LoadingProjects = false;
                });
        }
    };

    $scope.LoadContainers = function () {
        if ($scope.Containers.length < 2 && !$scope.LoadingContainers) {
            $scope.LoadingContainers = true;
            myApiService
                .GetData('cc').then(function (data) {
                    $scope.Containers = data.data.containers;
                    $scope.LoadingContainers = false;
                });
        }
    };

    $scope.LoadEndpoints = function () {
        if ($scope.Endpoints.length === 0 && !$scope.LoadingEndpoints) {
            if ($scope.PublicKeys === null)
                LoadPublicKeys();

            $scope.LoadingEndpoints = true;
            myApiService
                .GetData('epc').then(function (data) {
                    $scope.Endpoints = data.data.endpoints;
                    $scope.Containers = data.data.containers;
                    $scope.LoadingEndpoints = false;
                });
        }
    };

    $scope.LoadPublicKeys = function () {
        if ($scope.PublicKeys.length === 0 && !$scope.LoadingPublicKeys) {
            $scope.LoadingPublicKeys = true;
            myApiService
                .GetData('pk').then(function (data) {
                    $scope.PublicKeys = data.data.publickeys;
                    $scope.LoadingPublicKeys = false;
                });
        }
    };

    $scope.LoadConnectors = function () {
        if ($scope.Connectors.length === 0 && !$scope.LoadingConnectors) {
            $scope.LoadingConnectors = true;
            myApiService
                .GetData('sc').then(function (data) {
                    $scope.Connectors = data.data.connectors;
                    $scope.LoadingConnectors = false;
                });
        }
    };

    $scope.LoadLogs = function (date) {
        if (!$scope.LoadingLog) {
            $scope.LoadingLog = true;
            $scope.Logs = [];
            myApiService
                .GetLogs(date).then(function (data) {
                    $scope.Logs = data.data;
                    $scope.LoadingLog = false;
                });
        }
    };


    //Web APPS
    $scope.Shis = [];

    $scope.LoadShis = function () {
        if ($scope.Shis.length === 0) {
            myApiService
                .List('hoxshi', {}).then(function (res) {
                    $scope.Shis = res.data;
                });
        }
    };

    //PLAY
    $scope.LoadingPlay = false;
    $scope.Playing = false;
    $scope.EditingPlay = false;
    $scope.SelPlay = [];
    $scope.PlayItems = [];
    $scope.alias = "";
    $scope.PlayUrl = "";
    $scope.OriginalUrl = "";
    $scope.Features = [];
    $scope.SelectedTemplate = null;

    $scope.LoadPlay = function () {
        if (!$scope.LoadingPlay) {
            $scope.LoadingPlay = true;
            $scope.PlayItems = [];
            myApiService
                .GetPlayList().then(function (data) {
                    $scope.PlayItems = data.data;
                    $scope.LoadingPlay = false;
                });
            myApiService
                .GetAlias().then(function (data) {
                    $scope.alias = data.data;
                });
        }
    };
    
    $scope.NewPlay = function (value) {
        $scope.EditingPlay = value;        
        if (value) {
            $scope.LoadingPlay = true;
            myApiService
                .GetFeaturesList().then(function (data) {
                    $scope.SelPlay = [];
                    $scope.Features = data.data.results;
                    $scope.LoadingPlay = false;
                    $scope.SelectedTemplate = null;
                });
        }
    };

    $scope.LoadTemplate = function () {
        if ($scope.SelectedTemplate) {
            $scope.SelPlay = $filter('filter')($scope.Features, { 'tag': $scope.SelectedTemplate })[0];
            $scope.SelPlay._id = null;
            $scope.SelPlay.tag = "";
        }
    };    

    $scope.SaveNewAndSelectPlay = function () {
        var response = myApiService.SaveNewPlay($scope.SelPlay);
        response.then(function (res) {
            $scope.isLoading = false;
            if (res.data.success === true) {
                $mdToast.show(
                    $mdToast.simple()
                        .textContent(res.data.message)
                        .hideDelay(3000)
                );
                $scope.SelPlay._id = res.data.result;
                $scope.EditingPlay = false;
                $scope.PlayItems.push($scope.SelPlay);
                $scope.SelectPlay($scope.SelPlay);
            }
            else {
                $mdToast.show(
                    $mdToast.simple()
                        .textContent(res.data.error)
                        .hideDelay(3000)
                );
            }
        });
    };

    $scope.SelectPlay = function (play) {
        if (play) {
            $scope.Playing = true;
            $scope.SelPlay = play;


            var hteditor = ace.edit("hteditor");
            hteditor.setTheme("ace/theme/chrome");
            hteditor.session.setMode("ace/mode/html");
            hteditor.getSession().setTabSize(2);
            hteditor.getSession().setUseWrapMode(true);
            hteditor.getSession().setValue(play.html);

            var jseditor = ace.edit("jseditor");
            jseditor.setTheme("ace/theme/chrome");
            jseditor.session.setMode("ace/mode/javascript");
            jseditor.getSession().setTabSize(2);
            jseditor.getSession().setUseWrapMode(true);

            if (play.js)
                jseditor.getSession().setValue(play.js);
            else jseditor.getSession().setValue('');

            var csseditor = ace.edit("csseditor");
            csseditor.setTheme("ace/theme/chrome");
            csseditor.session.setMode("ace/mode/html");
            csseditor.getSession().setTabSize(2);
            csseditor.getSession().setUseWrapMode(true);
            if (play.css)
                csseditor.getSession().setValue(play.css);
            else csseditor.getSession().setValue('');


            var urlpre = 'https://';
            var urlpos = 'hoxwi.com';
            var tmptag = 'hoxwipreviewtag';
            if (play.area.toLowerCase() === "wi") {
                $scope.PlayUrl = urlpre + urlpos + '/Wi/form/';
            }
            if (play.area.toLowerCase() === "pages") {
                $scope.PlayUrl = urlpre + $scope.alias + '.' + urlpos + '/Pages/';
            }
            if (play.area.toLowerCase() === "app") {
                $scope.PlayUrl = urlpre + $scope.alias + '.' + urlpos + '/App/';
            }
            $scope.OriginalUrl = $scope.PlayUrl + play.tag;
            $scope.PlayUrl += tmptag;            
        }
    };

    $scope.CancelAndStopPlaying = function () {
            $scope.Playing = false;
            $scope.SelPlay = [];
    };

    $scope.SaveAndStopPlaying = function () {
        var hteditor = ace.edit("hteditor");
        var jseditor = ace.edit("jseditor");
        var csseditor = ace.edit("csseditor");

        $scope.SelPlay.html = hteditor.getValue();
        $scope.SelPlay.js = jseditor.getValue();
        $scope.SelPlay.css = csseditor.getValue();

        var response = myApiService.SavePlay($scope.SelPlay);
        response.then(function (res) {
            $scope.isLoading = false;
            if (res.data.success === true) {
                $mdToast.show(
                    $mdToast.simple()
                        .textContent(res.data.message)
                        .hideDelay(3000)
                );
                $scope.Playing = false;
                $scope.SelPlay = [];
            }
            else {
                $mdToast.show(
                    $mdToast.simple()
                        .textContent(res.data.error)
                        .hideDelay(3000)
                );
            }
        });
    };

    $scope.PreviewPlay = function () {
        var hteditor = ace.edit("hteditor");
        var jseditor = ace.edit("jseditor");
        var csseditor = ace.edit("csseditor");

        $scope.SelPlay.html = hteditor.getValue();
        $scope.SelPlay.js = jseditor.getValue();
        $scope.SelPlay.css = csseditor.getValue();

        var response = myApiService.PreviewPlay($scope.SelPlay);
        response.then(function (res) {
            $scope.isLoading = false;
            if (res.data.success === true) {
                $mdToast.show(
                    $mdToast.simple()
                        .textContent(res.data.message)
                        .hideDelay(3000)
                );
                document.getElementById('preview').src = $scope.PlayUrl;
            }
            else {
                $mdToast.show(
                    $mdToast.simple()
                        .textContent(res.data.error)
                        .hideDelay(3000)
                );
            }
        });
    };

    //MICROSERVICES
    $scope.LoadingMicroservicess = false;
    $scope.Microserviceing = false;
    $scope.EditingMicroservice = false;
    $scope.SelMicroservice = [];
    $scope.MicroserviceItems = [];
    $scope.alias = "";

    $scope.LoadMicroservices = function () {
        if (!$scope.LoadingMicroservices) {
            $scope.LoadingMicroservices = true;
            $scope.MicroserviceItems = [];
            myApiService
                .GetMicroserviceList().then(function (data) {
                    $scope.MicroserviceItems = data.data;
                    $scope.LoadingMicroservices = false;
                });
            myApiService
                .GetAlias().then(function (data) {
                    $scope.alias = data.data;
                });
        }
    };


    $scope.NewMicroservice = function (value) {
        $scope.EditingMicroservice = value;
    };

    $scope.SelectMicroservice = function (microservice) {
        if (microservice) {
            $scope.Microserviceing = true;
            $scope.SelMicroservice = microservice;


            var cseditor = ace.edit("cseditor");
            cseditor.setTheme("ace/theme/chrome");
            cseditor.session.setMode("ace/mode/html");
            cseditor.getSession().setTabSize(2);
            cseditor.getSession().setUseWrapMode(true);
            cseditor.getSession().setValue(microservice.html);
        }
    };

    $scope.CancelAndStopMicroserviceing = function () {
        $scope.Microserviceing = false;
        $scope.SelMicroservice = [];
    };

    $scope.SaveAndStopMicroserviceing = function () {
        var cseditor = ace.edit("cseditor");

        $scope.SelMicroservice.code = cseditor.getValue();

        var response = myApiService.SaveMicroservice($scope.SelMicroservice);
        response.then(function (res) {
            $scope.isLoading = false;
            if (res.data.success === true) {
                $mdToast.show(
                    $mdToast.simple()
                        .textContent(res.data.message)
                        .hideDelay(3000)
                );
                $scope.Microserviceing = false;
                $scope.SelMicroservice = [];
            }
            else {
                $mdToast.show(
                    $mdToast.simple()
                        .textContent(res.data.error)
                        .hideDelay(3000)
                );
            }
        });
    };

    $scope.PreviewMicroservice = function () {
        var cseditor = ace.edit("cseditor");

        $scope.SelMicroservice.code = cseditor.getValue();

        var response = myApiService.PreviewMicroservice($scope.SelMicroservice);
        response.then(function (res) {
            $scope.isLoading = false;
            if (res.data.success === true) {
                $mdToast.show(
                    $mdToast.simple()
                        .textContent(res.data.message)
                        .hideDelay(3000)
                );
                document.getElementById('preview').src = $scope.MicroserviceUrl;
            }
            else {
                $mdToast.show(
                    $mdToast.simple()
                        .textContent(res.data.error)
                        .hideDelay(3000)
                );
            }
        });
    };

    //MEDIA
    $scope.LoadingImages = false;
    $scope.Images = [];

    $scope.LoadImagesList = function () {
        $scope.LoadingImages = true;
        var response = myApiService.GetCdnList();
        response.then(function (res) {
            $scope.LoadingImages = false;
            if (res.data.success === true) {
                $scope.Images = res.data.results;
            }
            else {
                $mdToast.show(
                    $mdToast.simple()
                        .textContent(res.data.error)
                        .hideDelay(3000)
                );
            }
        });
    };
  
    $scope.CopyToClipboard = function (itemid) {
        var copyText = document.getElementById(itemid);
        copyText.select();
        document.execCommand("copy");
        $mdToast.show(
            $mdToast.simple()
                .textContent(copyText.value + " - Copied to Clipboard")
                .hideDelay(5000)
        );
    }

});