﻿app.controller("docController", function ($scope, myDocService, $mdToast, $location, $mdDialog) {

    $scope.Categories = ["AngularJS",
        ".NET MVC",
        "Java",
        "Php",
        "Phyton",
        "Arduino"];

    $scope.listing = true;

    $scope.Docs = [];

    $scope.Release = function (id) {
        myDocService
            .Release(id).then(function (data) {
                if (data.data.apps)
                    $scope.Applications = data.data.apps;

                $scope.LoadingApplications = false;

                if (data.data.publickeys)
                    $scope.PublicKeys = data.data.publickeys;

                $scope.LoadingPks = false;

                if (data.data.containers)
                    $scope.Containers = data.data.containers;

                $scope.LoadingContainers = false;

                if (data.data.endpoints)
                    $scope.Endpoints = data.data.endpoints;

                $scope.LoadingEndpoints = false;
                $scope.Account = data.data.account;
                $scope.LoadingAccount = false;
            });
    };

    $scope.SearchDocs = function (term) {

        $scope.isLoading = true;

        myDocService
            .SearchBlobs(term).then(function (res) {
                $scope.Docs = res.data.results;
                $scope.isLoading = false;
                $scope.listing = true;
            });
    }

    $scope.DocsByTag = function (tag) {

        $scope.isLoading = true;

        myDocService
            .DocsByTag(tag).then(function (res) {
                $scope.Docs = res.data.results;
                $scope.isLoading = false;
                $scope.listing = true;
            });
    }

    $scope.FeaturedDocs = function () {

        $scope.isLoading = true;

        myDocService
            .FeaturedDocs().then(function (res) {
                if (res.data.success) {
                    $scope.Docs = res.data.results;
                    $scope.success = true;
                } else $scope.success = false;
                $scope.isLoading = false;
                $scope.listing = true;
            });
    }

    $scope.DocsByCategory = function (categ) {

        $scope.isLoading = true;

        myDocService
            .DocsByCategory(categ).then(function (res) {
                if (res.data.success) {
                    $scope.Docs = res.data.results;
                    $scope.success = true;
                } else $scope.success = false;
                $scope.isLoading = false;
                $scope.listing = true;
            });
    }

    $scope.success = false;

    $scope.DocComments = [];

    $scope.Gettag = function (tag) {

        $scope.isLoading = true;

        myDocService
            .Gettag(tag).then(function (res) {
                if (res.data.success) {
                    $scope.Docs = res.data.doc.results;
                    $scope.DocComments = res.data.comments;
                    $scope.success = true;
                } else $scope.success = false;
                $scope.isLoading = false;
                $scope.listing = false;
            });
    }

    $scope.Getpost = function (id) {

        $scope.isLoading = true;

        myDocService
            .Getpost(id).then(function (res) {
                if (res.data.success) {
                    $scope.Docs = res.data.doc.results;
                    $scope.DocComments = res.data.comments;
                    $scope.success = true;
                } else $scope.success = false;
                $scope.isLoading = false;
                $scope.listing = false;
            });
    }

    $scope.replytoid = '';
    $scope.currenttag = '';
    $scope.commenting = false;

    $scope.Reply = function (id, title, tag, ev) {
        $scope.replytoid = id;
        $scope.currenttag = tag;
        $scope.comentheader = 'Add a reply for "' + title + '"';
        $scope.commenting = true;
    };

    $scope.NewComment = function (tag, ev) {
        $scope.replytoid = '';
        $scope.currenttag = tag;
        $scope.comentheader = 'Add your comment';
        $scope.commenting = true;
    };

    $scope.CancelComment = function () {
        $scope.title = '';
        $scope.content = '';
        $scope.replytoid = '';
        $scope.commenting = false;
    };

    //authorized

    $scope.SaveComment = function () {
        $scope.isLoading = true;

        var form =
            {
                title: $scope.title,
                content: $scope.content,
                tag: $scope.currenttag,
                replyto: $scope.replytoid
            };

        var response = myDocService.AddDocComment(form);
        response.then(function (res) {
            if (res.data.success == true) {
                $mdToast.show(
                    $mdToast.simple()
                        .textContent(res.data.message)
                        .hideDelay(5000)
                );
                form._id = res.data.result;
                form.author = 'You';
                form.hCreationDate = 'Now';
                $scope.DocComments.push(form);
                $scope.replytoid = '';
                $scope.title = '';
                $scope.content = '';
                $scope.commenting = false;
            }
            else {
                $scope.isLoading = false;
                $mdToast.show(
                    $mdToast.simple()
                        .textContent(res.data.error)
                        .hideDelay(false)
                        .hideDelay(5000)
                );
            }
        });
    }

    $scope.AddDoc = function () {
        $scope.isLoading = true;

        var form =
            {
                title: $scope.title,
                category: $scope.category,
                searchtags: $scope.searchtags,
                resume: $('.docpost-resume').summernote('code'),
                content: $('.docpost-content').summernote('code')
            };

        var response = myDocService.AddDoc(form);
        response.then(function (res) {
            if (res.data.success == true) {
                $mdToast.show(
                    $mdToast.simple()
                        .textContent(res.data.message)
                        .hideDelay(5000)
                );
                form._id = res.data.result;
                form.author = 'You';
                form.hCreationDate = 'Now';
                $scope.MyDocs.push(form);
            }
            else {
                $scope.isLoading = false;
                $mdToast.show(
                    $mdToast.simple()
                        .textContent(res.data.error)
                        .hideDelay(false)
                        .hideDelay(5000)
                );
            }
        });
    }

    $scope.MyDocs = [];

    $scope.MyList = function () {

        $scope.isLoading = true;

        myDocService
            .MyDocs().then(function (data) {
                $scope.MyDocs = data.data;
                $scope.isLoading = false;
            });
    }

    $scope.MyDoc = function (id) {

        $scope.isLoading = true;

        myDocService
            .Mydoc(id).then(function (data) {
                $scope.isLoading = false;
                return data.data;
            });
    }

    $scope.detailsDialog = function (option, ev) {
        $mdDialog.show({
            controller: DialogController,
            templateUrl: '/Components/' + option + '.html',
            parent: angular.element(document.body),
            targetEvent: ev,
            clickOutsideToClose: true
        });
    };

    function DialogController($scope, $mdDialog) {
        $scope.displaylist = true;

        $scope.hide = function () {
            $mdDialog.hide();
        };

        $scope.cancel = function () {
            $mdDialog.cancel();
        };

        $scope.list = function (value) {
            $scope.displaylist = value;
        };

        $scope.save = function () {
            $mdDialog.hide();
        };
    }
});