﻿app.controller("shiController", function ($scope, myShiService, $mdToast, $location, $sce) {

    $scope.Categories = ["Portal"];

    $scope.listing = true;

    $scope.SearchShis = function (term) {

        $scope.isLoading = true;

        myShiService
            .SearchForms(term).then(function (res) {
                $scope.Shis = res.data.results;
                $scope.isLoading = false;
                $scope.listing = true;
            });
    }

    $scope.ShisByTag = function (tag) {

        $scope.isLoading = true;

        myShiService
            .ShisByTag(tag).then(function (res) {
                $scope.Shis = res.data.results;
                $scope.isLoading = false;
                $scope.listing = true;
            });
    }

    $scope.FeaturedShis = function () {

        $scope.isLoading = true;

        $scope.SelCateg = "All";

        myShiService
            .FeaturedShis().then(function (res) {
                if (res.data.success) {
                    $scope.Shis = res.data.results;
                    $scope.success = true;
                } else $scope.success = false;
                $scope.isLoading = false;
                $scope.listing = true;
            });
    }

    $scope.SelCateg = "All";

    $scope.ShisByCategory = function (categ) {

        $scope.isLoading = true;

        $scope.SelCateg = categ;

        myShiService
            .ShisByCategory(categ).then(function (res) {
                if (res.data.success) {
                    $scope.Shis = res.data.results;
                    $scope.success = true;
                } else $scope.success = false;
                $scope.isLoading = false;
                $scope.listing = true;
                $scope.isEditing = false;
            });
    }

    $scope.success = false;

    $scope.Form = null;

    $scope.Items = [];

    $scope.Lists = [];

    $scope.tag = null;
    $scope.user = null;
    $scope.privilege = null;

    $scope.SetAlias = function (alias, tag) {
        $scope.alias = alias;
        $scope.tag = tag;
    }

    $scope.Setup = function (tag, user, privilege) {
        $scope.tag = tag;
        $scope.user = user;
        $scope.privilege = privilege;
    }

    $scope.List = function (container, filter) {
        myShiService
            .List(container, filter).then(function (res) {
                $scope.Lists.push(res.data);
            });
    };

    $scope.Getform = function (tag) {

        $scope.isLoading = true;

        myShiService
            .Getform(tag).then(function (res) {
                if (res.data.success) {
                    $scope.Form = res.data.form;
                    $scope.Items = res.data.items;
                    $scope.success = true;
                    $scope.tag = tag;
                    $scope.SelCateg = res.data.form.category;
                    $scope.listing = false;
                }
                else {
                    $mdToast.show(
                        $mdToast.simple()
                            .textContent(res.data.error)
                            .hideDelay(5000)
                    );
                }

                $scope.isLoading = false;                
            });
    }

    $scope.SelItem = null;

    $scope.isEditing = false;

    $scope.NewItem = function (status) {
        $scope.isEditing = status;
        $scope.SelItem = {};
        $scope.SelItem._id = null;
    }

    $scope.BeginUpdateItem = function (item) {
        $scope.isEditing = true;
        $scope.SelItem = item;
    }

    $scope.BeginCloneItem = function (item) {
        $scope.isEditing = true;
        $scope.SelItem = item;
        $scope.SelItem._id = null;
    }

    $scope.UpdateItem = function () {

        $scope.LoadingItem = true;

        if ($scope.SelItem._id != null) {
            var response = myShiService.Update($scope.tag, $scope.SelItem);
            response.then(function (res) {
                $scope.LoadingItem = false;
                if (res.data.success == true) {
                    $mdToast.show(
                        $mdToast.simple()
                            .textContent(res.data.message)
                            .hideDelay(5000)
                    );
                    $scope.isEditing = false;
                }
                else {
                    $mdToast.show(
                        $mdToast.simple()
                            .textContent(res.data.error)
                            .hideDelay(5000)
                    );
                }
            });
        }
        else
        {
            var response = myShiService.Insert($scope.tag, $scope.SelItem);
            response.then(function (res) {
                $scope.LoadingItem = false;
                if (res.data.success == true) {
                    $mdToast.show(
                        $mdToast.simple()
                            .textContent(res.data.message)
                            .hideDelay(5000)
                    );
                    $scope.isEditing = false;
                    $scope.SelItem._id = res.data.result;
                    $scope.Items.push($scope.SelItem);
                }
                else {
                    $mdToast.show(
                        $mdToast.simple()
                            .textContent(res.data.error)
                            .hideDelay(5000)
                    );
                }
            });
        }
    };



    $scope.DeletingItem = false;

    $scope.DeleteItem = function (item) {
        swal({
            title: "Attention", text: "This action can't be undone. Are you sure do you want to delete this item?", type: "warning", showCancelButton: true, confirmButtonColor: "#DD6B55",
            confirmButtonText: "Yes", cancelButtonText: "No", closeOnConfirm: true
        }, function () {
            $scope.DeletingItem = true;
            var response = myShiService.Delete($scope.tag, item._id);
            response.then(function (res) {
                $scope.DeletingItem = false;
                if (res.data.success == true) {
                    $mdToast.show(
                        $mdToast.simple()
                            .textContent(res.data.message)
                            .hideDelay(3000)
                    );
                    var index = $scope.Items.indexOf(item);
                    $scope.Items.splice(index, 1);
                }
                else {
                    $mdToast.show(
                        $mdToast.simple()
                            .textContent(res.data.error)
                            .hideDelay(3000)
                    );
                }
            });
        });
    };
    
});