﻿app.controller("shiPrivateController", function ($scope, myPrivateShiService, $mdToast, $location, $sce) {

    $scope.success = false;
    $scope.isLoading = false;

    $scope.Form = null;

    $scope.Items = [];

    $scope.Lists = [];

    $scope.tag = null;
    $scope.user = null;
    $scope.privilege = null;

    $scope.SetTag = function (tag) {
        $scope.tag = tag;
    }

    $scope.Setup = function (tag,user,privilege) {
        $scope.tag = tag;
        $scope.user = user;
        $scope.privilege = privilege;
    }

    $scope.client = null;
    $scope.Messages = [];

    $scope.StartMqtt = function(exchange, queue, user, pwd, alias) {
        $scope.client = Stomp.client('ws://www.hoxwi.com:15674/ws');

        var callback = function (message) {
            // called when the client receives a STOMP message from the server
            if (message.body) {
                $scope.Messages.push(message.body);
            } 
        };

        var on_connect = function (x) {
            $scope.client.subscribe("/"+exchange+"/"+queue, callback);
        };
        var on_error = function () {
            console.log('error');
        };
        $scope.client.connect(user, pwd, on_connect, on_error, alias);
    }

    $scope.List = function (container, filter) {

        $scope.isLoading = true;

        myPrivateShiService
            .List(container, filter).then(function (res) {
                $scope.Lists.push(res.data);
                $scope.isLoading = false;
            });
    }

    $scope.Load = function (tag, filter) {
        $scope.Form = { html: '<div class="localloader ml-5"><img src="/images/loading.gif"></div>' };
        $scope.Getform(tag, filter);
    }

    $scope.Getform = function (tag, filter) {

        $scope.isLoading = true;
        $scope.Reset();

        if (filter) {
            myPrivateShiService
                .GetformWithFilteredData(tag, filter).then(function (res) {
                    if (res.data.success) {
                        $scope.Form = res.data.form;

                        $scope.Items = res.data.items;

                        $scope.success = true;
                        $scope.tag = tag;
                        $scope.SelCateg = res.data.form.category;
                    }
                    else {
                        $scope.success = false;
                        $scope.Form = { html: '<div class="localloader ml-5">' + res.data.error + '</div>' };
                    }
                    $scope.isLoading = false;
                    $scope.listing = false;
                });

        }
        else {
            myPrivateShiService
                .Getform(tag).then(function (res) {
                    if (res.data.success) {
                        $scope.Form = res.data.form;
                        $scope.Items = [];
                        $scope.success = true;
                        $scope.tag = tag;
                        $scope.SelCateg = res.data.form.category;
                    }
                    else {
                        $scope.success = false;
                        $scope.Form = { html: '<div class="localloader ml-5">' + res.data.error + '</div>' };
                    }
                    $scope.isLoading = false;
                    $scope.listing = false;
                });
        }
    }

    $scope.SelItem = null;

    $scope.isEditing = false;

    $scope.Reset = function () {
        $scope.isEditing = false;
        $scope.SelItem = {};
        $scope.SelItem._id = null;
    }

    $scope.NewItem = function (status) {
        $scope.isEditing = status;
        $scope.SelItem = {};
        $scope.SelItem._id = null;
    }

    $scope.BeginUpdateItem = function (item) {
        $scope.isEditing = true;
        $scope.SelItem = item;
    }

    $scope.BeginCloneItem = function (item) {
        $scope.isEditing = true;
        $scope.SelItem = item;
        $scope.SelItem._id = null;
    }

    $scope.UpdateItem = function (itemsArray) {

        $scope.isEditing = true;

        if ($scope.SelItem._id != null) {
            var response = myPrivateShiService.Update($scope.tag, $scope.SelItem);
            response.then(function (res) {
                $scope.LoadingItem = false;
                if (res.data.success == true) {
                    $mdToast.show(
                        $mdToast.simple()
                            .textContent(res.data.message)
                            .hideDelay(5000)
                    );
                    $scope.isEditing = false;
                }
                else {
                    $mdToast.show(
                        $mdToast.simple()
                            .textContent(res.data.error)
                            .hideDelay(5000)
                    );
                }
            });
        }
        else
        {
            var response = myPrivateShiService.Insert($scope.tag, $scope.SelItem);
            response.then(function (res) {
                $scope.isEditing = false;
                if (res.data.success == true) {
                    $mdToast.show(
                        $mdToast.simple()
                            .textContent(res.data.message)
                            .hideDelay(5000)
                    );
                    $scope.isEditing = false;
                    $scope.SelItem._id = res.data.result;

                    if (itemsArray)
                        itemsArray.push($scope.SelItem);
                    else
                        $scope.Items.push($scope.SelItem);
                }
                else {
                    $mdToast.show(
                        $mdToast.simple()
                            .textContent(res.data.error)
                            .hideDelay(5000)
                    );
                }
            });
        }
    };

    $scope.DeleteItem = function (item) {
        swal({
            title: "Attention", text: "This action can't be undone. Are you sure do you want to delete this item?", type: "warning", showCancelButton: true, confirmButtonColor: "#DD6B55",
            confirmButtonText: "Yes", cancelButtonText: "No", closeOnConfirm: true
        }, function () {
            $scope.isLoading = true;
            var response = myPrivateShiService.Delete($scope.tag, item._id);
            response.then(function (res) {
                $scope.isLoading = false;
                if (res.data.success == true) {
                    $mdToast.show(
                        $mdToast.simple()
                            .textContent(res.data.message)
                            .hideDelay(3000)
                    );
                    if (itemsArray) {
                        var index = itemsArray.indexOf(item);
                        itemsArray.splice(index, 1);
                    }
                    else {
                        var index = $scope.Items.indexOf(item);
                        $scope.Items.splice(index, 1);
                    }
                }
                else {
                    $mdToast.show(
                        $mdToast.simple()
                            .textContent(res.data.error)
                            .hideDelay(3000)
                    );
                }
            });
        });
    };
    
});