﻿app.controller("shiPublicController", function ($scope, myShiPublicService, $mdToast, $location) {

    $scope.isLoading = false;

    $scope.isSaving = false;

    $scope.message = '';

    $scope.alias = null;

    $scope.Setup = function (alias, tag) {
        $scope.alias = alias;
        $scope.tag = tag;
    };

    $scope.SelItem = null;

    $scope.Items = [];

    $scope.Lists = [];

    $scope.tag = null;
    
    $scope.isEditing = false;

    $scope.Reset = function () {
        $scope.isEditing = false;
        $scope.SelItem = {};
        $scope.SelItem._id = null;
    };
        
    $scope.NewItem = function (status) {
        $scope.isEditing = status;
        $scope.SelItem = {};
        $scope.SelItem._id = null;
    };

    $scope.BeginUpdateItem = function (item) {
        $scope.isEditing = true;
        $scope.SelItem = item;
    };

    $scope.BeginCloneItem = function (item) {
        $scope.isEditing = true;
        $scope.SelItem = item;
        $scope.SelItem._id = null;
    };

    $scope.List = function (container, filter) {
        myShiPublicService
            .List(container, filter).then(function (res) {
                if (res.data.success)
                    $scope.Lists.push(res.data.results);
            });
    };

    this.GetActionToList = function (action, pk) {
        myShiPublicService
            .GetAction(action, pk).then(function (res) {
                $scope.Lists.push(res.data);
            });
    };

    this.PutActionToList = function (action, pk, form) {
        myShiPublicService
            .PutAction(action, pk, form).then(function (res) {
                $scope.Lists.push(res.data);
            });
    };

    $scope.Load = function (tag) {
        $scope.Form = { html: '<div class="localloader ml-5"><img src="/images/loading.gif"></div>' };
        $scope.Getform(tag);
    };

    $scope.Getform = function (tag) {

        $scope.isLoading = true;

        myShiPublicService
            .Getform($scope.alias, tag).then(function (res) {
                if (res.data.success) {
                    $scope.Form = res.data.form;
                    $scope.Items = res.data.items;
                    $scope.success = true;
                    $scope.tag = tag;
                } else $scope.success = false;
                $scope.isLoading = false;
                $scope.listing = false;
            });
    };

    $scope.Order = null;

    $scope.CreateOrder = function (id, tag) {

        $scope.isLoading = true;

        $scope.tag = tag;

        myShiPublicService
            .CreateOrder(id).then(function (res) {
                if (res.data.success) {
                    $scope.Order = res.data;
                    $scope.success = true;
                } else $scope.success = false;
                $scope.isLoading = false;
            });
    };

    $scope.Save = function () 
    {
        $scope.isSaving = true;
        $scope.UpdateItem();        
    }

    $scope.UpdateItem = function (itemsArray) {

        $scope.isEditing = true;

        if ($scope.SelItem._id != null) {
            var response = myShiPublicService.Update($scope.tag, $scope.SelItem);
            response.then(function (res) {
                $scope.LoadingItem = false;
                if (res.data.success == true) {
                    $mdToast.show(
                        $mdToast.simple()
                            .textContent(res.data.message)
                            .hideDelay(5000)
                    );
                    $scope.isEditing = false;
                }
                else {
                    $mdToast.show(
                        $mdToast.simple()
                            .textContent(res.data.error)
                            .hideDelay(5000)
                    );
                }
            });
        }
        else {
            var response = myShiPublicService.Insert($scope.tag, $scope.SelItem);
            response.then(function (res) {
                $scope.isEditing = false;
                if (res.data.success == true) {
                    $mdToast.show(
                        $mdToast.simple()
                            .textContent(res.data.message)
                            .hideDelay(5000)
                    );
                    $scope.isEditing = false;
                    $scope.SelItem._id = res.data.result;

                    if (itemsArray)
                        itemsArray.push($scope.SelItem);
                    else
                        $scope.Items.push($scope.SelItem);
                }
                else {
                    $mdToast.show(
                        $mdToast.simple()
                            .textContent(res.data.error)
                            .hideDelay(5000)
                    );
                }
            });
        }
    };

    $scope.DeleteItem = function (item) {
        swal({
            title: "Attention", text: "This action can't be undone. Are you sure do you want to delete this item?", type: "warning", showCancelButton: true, confirmButtonColor: "#DD6B55",
            confirmButtonText: "Yes", cancelButtonText: "No", closeOnConfirm: true
        }, function () {
            $scope.isLoading = true;
            var response = myShiPublicService.Delete($scope.tag, item._id);
            response.then(function (res) {
                $scope.isLoading = false;
                if (res.data.success == true) {
                    $mdToast.show(
                        $mdToast.simple()
                            .textContent(res.data.message)
                            .hideDelay(3000)
                    );                    
                    if (itemsArray) {
                        var index = itemsArray.indexOf(item);
                        itemsArray.splice(index, 1);
                    }
                    else {
                        var index = $scope.Items.indexOf(item);
                        $scope.Items.splice(index, 1);
                    }
                }
                else {
                    $mdToast.show(
                        $mdToast.simple()
                            .textContent(res.data.error)
                            .hideDelay(3000)
                    );
                }
            });
        });
    };

    $scope.DeployToNewHoxWiAcc = function () {

        $scope.isLoading = true;
        $scope.isSaving = true;

        var response = myShiPublicService.CreateAccount($scope.SelItem);
        response.then(function (res) {

            if (res.data.success == true) {
                $scope.message = "Your account was created with success. The activation link was sent to the registered email.";
            }
            else {
                $scope.message = res.data.error;
                $scope.isSaving = false;
            }
            $scope.isLoading = false;
        });
    }

    
});